
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
-- library UNISIM;
-- use UNISIM.VComponents.all;

entity Lab2 is
    Port ( A : in STD_LOGIC_VECTOR (4 downto 0);
           B : in STD_LOGIC_VECTOR (4 downto 0);
           I : in STD_LOGIC;
           S : out STD_LOGIC_VECTOR (7 downto 0));
end Lab2;

architecture Behavioral of lab2 is
-- declaracao do componente somador8
component somador8 
    Port ( P : in STD_LOGIC_VECTOR (7 downto 0);
           Q : in STD_LOGIC_VECTOR (7 downto 0);
           cin : in STD_LOGIC;
           R : out STD_LOGIC_VECTOR (7 downto 0);
          cout : out STD_LOGIC);
end component;

-- declaracao dos sinais internos
signal sign_a, sign_b : std_logic_vector (7 downto 0);

signal som1_P, som1_Q, som1_S : std_logic_vector (7 downto 0);
signal som1_cin : std_logic;

signal som2_P, som2_Q, som2_S : std_logic_vector (7 downto 0);
signal som2_cin : std_logic;

-- declaracao de sinais adicionais que possam ser nencessarios

begin
-- criacao do sinal sign_A e sign_B, i.e., extensao do sinal A e B repetindo o bit mais significativo de duas formas alternativas
-- simbolo "&" representa a concatenacao dos bits
-- expresso "(7 downto 5 => B(9))" representa a repetico do bit de sinal B(4) nos bits 7, 6, e 5 de sign_B
sign_A <= A(4) & A(4) & A(4) & A(4 downto 0);
sign_B <= (7 downto 5 => B(4)) & B;

-- instancia dos SOMADORES (port map)
-- no modificar
SOM1: somador8 port map (
        P => som1_P, Q => som1_Q, cin => som1_cin,
        R => som1_S 
    );

SOM2: somador8 port map (
        P => som2_P, Q => som2_Q, cin => som2_cin,
        R => som2_S 
    );    
    
-- exemplo de um MUX2:1 de 8 bits controlado por I, com entradas sign_A e "00000000", 
-- ligado na entrada P do somador 1
-- DEVE SER MODIFICADO
    with I select
        som1_P <= sign_A   when '0',
                 "00000000" when others;

-- atribuio das outras entradas dos somadores
-- DEVE SER MODIFICADO 
    som1_Q <= sign_B;
    som1_cin <= '0';
    
    
    som2_P <= sign_A;
    som2_Q <= sign_B;
    som2_cin <= '0';

-- atribuio da sada do circuito aritmtico projectado
-- DEVE SER MODIFICADO 
    S <= "00000000";
    
end Behavioral;
